// ShellLinkTest.cpp
// Copyright (C) 2018 Katayama Hirofumi MZ.
// This file is public domain software (PDS).
#include <windows.h>
#include <tchar.h>
#include <shlobj.h>
#include <stdio.h>

#pragma comment(lib, "ole32.lib")
#pragma comment(lib, "shell32.lib")
#pragma comment(lib, "uuid.lib")

BOOL CreateShortcut(
    LPCWSTR pszLnkFileName, 
    LPCWSTR pszTargetPathName, 
    LPCWSTR pszDescription = NULL,
    LPCWSTR pszIconPath = NULL, INT iIcon = 0)
{
    HRESULT hres;
    IPersistFile *ppf;
    IShellLink *psl;

    hres = CoCreateInstance(CLSID_ShellLink, NULL, 
        CLSCTX_INPROC_SERVER, IID_IShellLink, (LPVOID*)&psl);
    if (SUCCEEDED(hres))
    {
        psl->SetPath(pszTargetPathName);
        if (pszDescription != NULL)
            psl->SetDescription(pszDescription);

        printf("Ready for SetIconLocation?");
        fflush(stdout);
        getchar();
        if (pszIconPath)
            psl->SetIconLocation(pszIconPath, iIcon);

        printf("Ready for QueryInterface?");
        fflush(stdout);
        getchar();

        hres = psl->QueryInterface(IID_IPersistFile, (LPVOID*)&ppf);
        if (SUCCEEDED(hres))
        {
            printf("Ready for Save?");
            fflush(stdout);
            getchar();

            hres = ppf->Save(pszLnkFileName, TRUE);
            ppf->Release();
        }
        psl->Release();
    }

    return SUCCEEDED(hres);
}

int main(void)
{
    HRESULT hres = CoInitialize(NULL);
    if (!SUCCEEDED(hres))
    {
        printf("CoInitialize failed\n");
        return 1;
    }

    CreateShortcut(
        L"C:\\Program Files\\a.lnk", L"C:\\Program Files\\a.txt",
        L"This is a shortcut file.",
        L"C:\\Program Files\\a.ico", 0);

    CoUninitialize();
    return 0;
}
